/*
* ASIX up_control.dll interface
* It is distributed as-is, without any warranties.
* http://www.asix.net/
*
* version 1.0, September 2019
* 
*/



#ifndef UP_CONTROL_H_
#define UP_CONTROL_H_

#include <windows.h>

int (__stdcall *UP_Prog)(int prog_index, int code, int data, int boot, int cfg);
int (__stdcall *UP_DiffProg)(int prog_index, int code, int data, int boot, int cfg);
int (__stdcall *UP_Erase)(int prog_index, int code, int data, int boot);
int (__stdcall *UP_BlankCheck)(int prog_index, int code, int data, int boot, int cfg);
int (__stdcall *UP_Verify)(int prog_index, int code, int data, int boot, int cfg);
int (__stdcall *UP_Read)(int prog_index, int code, int data, int boot, int cfg);

int (__stdcall *UP_ProgState)(int prog_index, int *ProgressBarValue);
int (__stdcall *UP_LastErrorCode)(int prog_index);
int (__stdcall *UP_ProgConfig)(int Prog_index, char *UP_project, int prog_type, int prog_SN, char *NewDataFile, char *EEFile); 
int (__stdcall *UP_SetManualSN)(int prog_index, int DefineSN, int SN);
int (__stdcall *UP_GetProgList)(int prog_type, int *sn_list, int count, int *count_returned);



int Load_UP_control_dll(char* filename);


HMODULE hUP_control_dll; 

#define DLL_LOAD_OK           0
#define DLL_LOAD_ERROR        1
#define DLL_LOAD_FILE_ERROR   2

#define ERR_NONE                 0
#define ERR_PROG_BUSY            1
#define ERR_UP_MISSING           2
#define ERR_WRONG_PROG_INDEX     3
#define ERR_NOT_CONFIGURED       4
#define ERR_FILE_DOES_NOT_EXIST  5

#define PROG_STATE_DONE          0
#define PROG_STATE_BUSY          1
#define PROG_STATE_NOT_USED      2
#define PROG_STATE_WRONG_INDEX   3

#define SET_PROG_FROM_PROJECT    0
#define SET_PROG_PRESTO          1
#define SET_PROG_FORTE           2

#define PROG_PRESTO              1
#define PROG_FORTE               2
 

#endif
